# Naxos Solver User's Guide

_Naxos Solver_ is a constraint satisfaction problems
_solver_. "_Naxos_" is the name of the Greek island where
the solver was built in the beginning. It is implemented and
maintained by the author, under the supervision of Assistant
Professor Panagiotis Stamatopoulos at the Department of
Informatics and Telecommunications of the National and
Kapodistrian University of Athens. The aim of this handbook
is to provide all the information needed by an application
developer of the library.

<p align="center">
  <img src="https://rawgit.com/pothitos/naxos-solver/master/manual/figures/logo.svg">
</p>


## Contents

 - [Introduction](Introduction.md)
 - [Error Handling](Errors.md)
 - [Constrained Variables](Variables.md)
 - [Constrained Variable Arrays](Arrays.md)
 - [Problem Manager](ProblemManager.md)
 - [Expressions](Expressions.md)
 - [__Examples__](Examples.md)
 - [Search via Goals](Goals.md)


## Acknowledgements

I am grateful to Prof. Panagiotis Stamatopoulos, not only
for his continuous and steady guidance, but also because he
inspired, encouraged, and embraced this attempt. I also
thank Kyriakos Zervoudakis, a B.Sc. and M.Sc. graduate of
the Department of Informatics and Telecommunications, that
helped me in my first steps in Constraint Programming in
2004. Finally, many thanks to all the students of the
Department that used the solver, either in the context of
diploma theses or through the Logic Programming course; we
managed to improve the solver through the interaction and
conversations between us. Unfortunately the name list is too
big to quote, but I personally thank you one and all!

---

 - [Next Section](Introduction.md)
